# Automata< Series, Kind > Class Template Reference

Final class for the set of automata. More...

Inheritance diagram for Automata< Series, Kind >:
[legend]

List of all members.

## Public Types

typedef virtual_types < Automata< Series, Kind > >::series_set_t | series_set_t
| The type of the series set associated with the automaton.
typedef virtual_types < Automata< Series, Kind > >::kind_t | kind_t
| The type of the label kind associated with the automaton.
typedef Automata< Series, Kind > | self_t
| Exact type of the most derived type in the hierarchy.

## Public Member Functions

const series_set_t & | series () const
| Accessor to the set of series of the automaton.
bool | contains (const Element< Automata< Series, Kind >, T > &elt) const
| Check if a given element is compatible with the structural element.
bool | contains (const Element< OtherS, T > &other) const
| Specialization of `contains` that always returns false.
bool | contains (const T &elt_value) const
| Check if an anonymous value is compatible with a structural element.
Element< Automata< Series, Kind >, T > | choose (SELECTOR(T)) const
| Choose randomly an element in the structure.
self_t & | self ()
| Accessor to the real type.
const self_t & | self () const
| Accessor to the real type.

## Private Member Functions

const Series & | _structure_get () const
| Access to the instance of the structural element.
bool | _structure_bound () const
| Whether the current set slot is linked to a structural element.
Methods to link the Slot
Because this version of the class pertains to static S.E. 's, those methods actually do nothing and calls to it should be optimized away.
void | _structure_assign (const SetSlotAttribute &other)
| Link a `SetSlot` to another.
void | _structure_attach (const Series &other)
| Link a `SetSlot` to a structural element.

## Detailed Description

### template<typename Series, typename Kind>
class vcsn::Automata< Series, Kind >

Final class for the set of automata.

Definition at line 56 of file automata.hh.

## Member Function Documentation

bool contains | ( | const Element< OtherS, T > & | other | ) | const`[inherited]`

Specialization of `contains` that always returns false.

Indeed, elements structured by a particular type are always incompatible with structural elements of another type.

self_t& self | ( |  | ) | `[inherited]`

Accessor to the real type.

To be used by implementations in this class and derived structures to obtain a reference to the structural element with its most derived type.

const self_t& self | ( |  | ) | const`[inherited]`

Accessor to the real type.

To be used by implementations in this class and derived structures to obtain a reference to the structural element with its most derived type.